// components/QuickGame/pay.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    fullscreen:{
      type:String,
      value:"true",
    },

    amount:{
      type:String,
      value:"0",
    },

    subject:{
      type:String,
      value:"游戏道具",
    },

    cporderno:{
      type:String,
      value:"",
    },

    userroleid:{
      type:String,
      value:"",
    },

    userrolename:{
      type:String,
      value:"",
    },

    serverid:{
      type:String,
      value:"",
    },

    servername:{
      type:String,
      value:"",
    },

    userlevel:{
      type:String,
      value:"",
    },

    desc:{
      type:String,
      value:"",
    },

    goodsid:{
      type:String,
      value:"",
    },

    extrasparams:{
      type:String,
      value:"",
    },
  },

  lifetimes: {
    attached: function() {
      console.log('has attached QG_PAY');

      this.data.productcode = wx.getStorageSync('productCode');
      this.data.channelcode = wx.getStorageSync('channelCode');
      this.data.host = wx.getStorageSync('host');
      this.data.userInfo = wx.getStorageSync('userInfo');
      this.data.payEnd = false;
      if(this.data.userInfo == null || this.data.userInfo == undefined || this.data.userInfo == ''){
        return this.setData({errorNo:1});
      }

      var buttonArea = wx.getMenuButtonBoundingClientRect();

      var systemSetting = wx.getSystemSetting();
      this.data.screenType = systemSetting.deviceOrientation;

      this.loadPayInfo();


      //实付金额
      this.setData({payAmount:this.data.amount,buttonTop:buttonArea.top});
    },
    detached: function() {
      // 在组件实例被从页面节点树移除时执行
    },
  },

  /**
   * 组件的初始数据
   */
  data: {
    showPage:1,//1登录页 
    userInfo:null,
    productcode:'',
    channelcode:'',
    host:'http://quickgame.sdk.quicksdk.net',
    screenType:1, //1竖屏 2横屏
    loadPayInfo:false,
    payInfo:{},
    selectPayType:88,
    payRate:1,
    payRateText:'',
    payAmount:0,
    errorNo:0,
    payPassword:'',
    nowIndex:1,
    resetPasswordPage:0,
    resetButtonStatus:false,
    newPayPass1:'',
    newPayPass2:'',
    payEnd:false,
    voucher:[],
    buttonTop:50,
    showPopup:false,
    voucherCode:'',
    vocherAmount:0,
    screenType:'portrait'
  },

  /**
   * 组件的方法列表
   */
  methods: {
    cancelPay:function(){
      this.triggerEvent('paycancel', {status:false,message:'点击取消支付按钮'}, {})
    },

    bindKeyInput_resetPass1:function(e){
      var val = e.detail.value;
      var valInt = parseInt(val);
      if(!isNaN(valInt) && valInt == val){
        this.setData({newPayPass1:val});
      }
      this.checkResetPassInput();
    },

    bindKeyInput_resetPass2:function(e){
      var val = e.detail.value;
      var valInt = parseInt(val);
      if(!isNaN(valInt) && valInt == val){
        this.setData({newPayPass2:val});
      }
      this.checkResetPassInput();
    },

    getPhoneNumber (e) {
      var phonecode = e.detail.code;
      if(phonecode == undefined){
        wx.showToast({
          title: '请允许手机验证',
          icon:'error'
        })
        return;
      }
  
      //调用login授权
      var that = this;
      wx.showLoading({
        title: '正在验证',
      })
      wx.request({
        url: that.data.host + '/wxmini/resetPassword',
        method:'GET',
        timeout:5000,
        data:{phonecode:phonecode,productCode:that.data.productcode,channelCode:that.data.channelcode,password:that.data.newPayPass1,authToken:that.data.userInfo.authToken},
        dataType:'json',
        success:function(result){
          wx.hideLoading();
          if(!result.data.result){
            wx.showModal({
              title: '提示',
              content:result.data.error.message?result.data.error.message:'请求接口失败',
            })
            return;
          }
  
          wx.showToast({
            title: '支付密码已重置',
            icon:'success',
          })
         
          that.setData({resetPasswordPage:0});
        },
        fail:function(){
          wx.hideLoading();
          wx.showToast({
            title: '请求失败',
            icon:'error'
          })
        },
        complete:function(){
        }
      })
    },

    checkResetPassInput:function(){
      var pass1 = this.data.newPayPass1;
      var pass2 = this.data.newPayPass2;
      var pass1Int = parseInt(pass1);
      
      if(!isNaN(pass1Int) && pass1 == pass2 && pass1.length == 6 && pass1Int == pass1){
        this.setData({resetButtonStatus:true});
      }else{
        this.setData({resetButtonStatus:false});
      }

    },

    checkPayAmount(){
      var payType = this.data.selectPayType;
      var payAmount = parseFloat(this.data.amount);
      if(payType == 88){
        var payRate = parseFloat(this.data.payRate);
        payAmount = payAmount*payRate;
      }

      payAmount = payAmount - parseFloat(this.data.vocherAmount);
      
      console.log(this.data.vocherAmount);

      if(payAmount < 0){
        payAmount = 0;
      }

      payAmount = payAmount.toFixed(2);
      this.setData({payAmount:payAmount});
    },

    radioChange:function(e){
      this.setData({selectPayType:e.detail.value});
      this.checkPayAmount();
    },

    doPayNotify:function(status,orderNo,orderAmount,payAmount){

      //向游戏发送通知  同时关闭界面
      this.setData({payEnd:true});

      this.triggerEvent('paysuccess', {status:status,data:{orderNo:orderNo,orderAmount:orderAmount,payAmount:payAmount},message:''}, {})
    },

    toPage_useId:function(e){
      var type = e.currentTarget.dataset.type;

      if(this.data.showPayPage == true){
        this.setData({showPayPage:false});
      }

      this.setData({showPage:type});
      if(type == 3){

        if(this.data.voucher.length == 0){
          return;
        }

        var that = this;
        setTimeout(function(){
          that.setData({showPopup:true});
        },50);
      }
    },

    closePopup:function(){
      var that = this;
      that.setData({showPopup:false});
      setTimeout(function(){
        that.setData({showPage:1});
      },300)

    },

    passwordInput:function(e){
      var val = parseInt(e.detail.value);
      var index = e.currentTarget.dataset.index;
      if(index == 1){
        this.data.payPassword = '';
      }
      var nextIndex = parseInt(index) + 1;
      this.data.payPassword += val.toString();
      this.setData({nowIndex:nextIndex});

      if(nextIndex == 7){
        this.createOrder();
        this.setData({showPage:1});
      }
    },

    wantResetPayword:function(){
      this.setData({resetPasswordPage:1});
    },

    closeResetPaywordPage:function(){
      this.setData({resetPasswordPage:0});
    },

    clearCoupon:function(){
      this.setData({voucherCode:'',vocherAmount:0});
      this.closePopup();
      this.checkPayAmount();
    },

    useCoupon:function(e){
      var code = e.currentTarget.dataset.code;
      if(code == '' || code == undefined){
        return wx.showToast({
          title: '代金券不可用',
          icon:'error'
        })
      }

      var vocherAmount = parseFloat(e.currentTarget.dataset.amount);

      this.setData({voucherCode:code,vocherAmount:vocherAmount});
      this.closePopup();
      this.checkPayAmount();
    },

    createOrder:function(){
      var params = {};
      params.productOrderNo = this.data.cporderno;
      params.deviceId = this.data.userInfo.userData.username;
      params.amount = this.data.amount;
      params.orderSubject = this.data.subject;
      params.extrasParams = this.data.extrasparams;
      params.serverName = this.data.servername;
      params.roleName = this.data.userrolename;
      params.roleLevel = this.data.userlevel;
      params.orderGoodsId = this.data.goodsid;
      params.payType = this.data.selectPayType;
      params.productCode = this.data.productcode;
      params.channelCode = this.data.channelcode;
      params.uid = this.data.userInfo.userData.uid
      params.authToken = this.data.userInfo.authToken;
      params.voucherCode = this.data.voucherCode;
      var that = this;
      if(params.payType == 173 && this.data.payPassword.length != 6){

        this.setData({showPage:2,nowIndex:1,payPassword:''});
        setTimeout(function(){
          that.setData({showPayPage:true});
        },50)
        return;
      }

      params.password = this.data.payPassword;
      var that = this;
      var payAmount = this.data.payAmount;

      wx.showLoading({
        title: '创建订单',
      })
      
      wx.request({
        url: that.data.host + '/wxmini/createOrder',
        method:'GET',
        data:params,
        dataType:'json',
        timeout:5000,
        success:function(result){
          wx.hideLoading();
          if(!result.data.result){
            try{
              var tips = result.data.error.message;
            }catch(e){
              var tips = '创建订单失败，请联系客服';
            }
            return wx.showModal({
              title:'错误提示',
              content:tips,
            })
          }

          var orderNo = result.data.data.orderNo;

          if(params.payType == 88){
            var payBackData = result.data.data.data;
            try{
              wx.requestPayment({
                timeStamp: payBackData.timeStamp,
                nonceStr: payBackData.nonceStr,
                package: payBackData.package,
                signType:payBackData.signType,
                paySign: payBackData.paySign,
                success (res) { 
                  that.doPayNotify(true,orderNo,params.amount,payAmount);
                },
                fail (res) { 
                  console.log(res);
                  wx.showModal({
                    title:'支付提示',
                    content:'调用微信支付失败，请联系客服 ' + res.errMsg,
                  })
                  that.doPayNotify(false,orderNo,params.amount,0);
                }
              })
            }catch(e){
              wx.showModal({
                title:'支付提示',
                content:'下单失败，请联系客服',
              })
            }
          }

          if(params.payType == 173){
            that.doPayNotify(true,orderNo,params.amount,payAmount);
          }

        },
        fail:function(){
          wx.hideLoading();
          wx.showToast({
            title: '网络失败请重试',
            icon:'error'
          })
        },
        complete:function(){
          that.setData({payPassword:'',nowIndex:1});
        }
      })
    },

    loadPayInfo:function(){
      var that = this;
      wx.request({
        url: that.data.host + '/wxmini/getPayInfo',
        method:'GET',
        data:{amount:that.data.amount,productCode:that.data.productcode,channelCode:that.data.channelcode,uid:that.data.userInfo.userData.uid,authToken:that.data.userInfo.authToken},
        dataType:'json',
        timeout:5000,
        success:function(result){
          if(result.data.result){
            var payInfo = result.data.data;
            that.setData({payInfo:payInfo});
            var payRate = 1;
            var payRateText = '';
            for(var i in payInfo.payTypes){
              var thisPay = payInfo.payTypes[i];

              if(thisPay.payTypeId == 88){
                payRate = thisPay.rebate.rate;
                payRateText = thisPay.rebate.rateval;
              }
            }

            var voucher = [];
            if(result.data.data.hasOwnProperty('vouchers')){
              voucher = result.data.data.vouchers;
            }
 
            that.setData({payRate:payRate,payRateText,voucher:voucher});
            that.checkPayAmount();
          }
        },
        fail:function(){
        },
        complete:function(){
        }
      })
    },
  }
})
