package com.example.myapplication;

import android.Manifest;
import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Build;

import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.Window;
import android.widget.EditText;
import android.widget.Toast;


import androidx.annotation.NonNull;
import androidx.core.app.ActivityCompat;

import com.huamei.dollstory.R;
import com.quickgamesdk.QGManager;
import com.quickgamesdk.callback.QGCallBack;
import com.quickgamesdk.entity.QGOrderInfo;
import com.quickgamesdk.entity.QGRoleInfo;

import tds.androidx.core.content.ContextCompat;


public class MainActivity extends Activity {

	private String tag = "channel";
	private Activity mActivity = null;
	private QGOrderInfo mOrderInfo = new QGOrderInfo();
	private QGRoleInfo mRoleInfo = new QGRoleInfo();
	EditText amountEditText;

	@Override
	protected void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);

		setContentView(R.layout.activity_main_qg_test);
		mActivity = this;

		mActivity.getLocalClassName();
		amountEditText = (EditText) findViewById(R.id.input_amount);
		setHideVirtualKey(getWindow());

		getWindow().getDecorView().setOnSystemUiVisibilityChangeListener(new View.OnSystemUiVisibilityChangeListener() {
			@Override
			public void onSystemUiVisibilityChange(int visibility) {
				setHideVirtualKey(getWindow());
			}
		});

		QGManager.setLogoutCallback(new QGCallBack() {
			@Override
			public void onSuccess() {
				Toast.makeText(mActivity, "注销成功", Toast.LENGTH_SHORT).show();
				QGManager.hideFloat();
			}

			@Override
			public void onFailed(String msg) {
				Toast.makeText(mActivity, "注销失败", Toast.LENGTH_SHORT).show();

			}
		});
		QGManager.showPrivace(this, new QGCallBack() {
			@Override
			public void onSuccess() {
				if (ContextCompat.checkSelfPermission(MainActivity.this, Manifest.permission.READ_PHONE_STATE)
						!= PackageManager.PERMISSION_GRANTED) {
					// 没有权限，可以在这里重新申请权限。
					ActivityCompat.requestPermissions(MainActivity.this, new String[]{Manifest.permission.READ_PHONE_STATE}, 1996);

				}else{
					// 有权限了。
					QGManager.init(MainActivity.this, "8cf0c4ea388c7d53435c1e361949f154", new QGCallBack() {

						@Override
						public void onSuccess() {
							Log.d(tag, "init success");
							Toast.makeText(mActivity, "初始化成功", Toast.LENGTH_SHORT).show();
						}

						@Override
						public void onFailed(String msg) {
							Toast.makeText(mActivity, "初始化失败:" + msg, Toast.LENGTH_SHORT).show();
						}
					});
				}

			}

			@Override
			public void onFailed(String s) {
				System.exit(0);
				finish();
			}
		});


	}

	@Override
	public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
		super.onRequestPermissionsResult(requestCode, permissions, grantResults);
		if (requestCode==1996){
			QGManager.init(MainActivity.this, "8cf0c4ea388c7d53435c1e361949f154", new QGCallBack() {

				@Override
				public void onSuccess() {
					Log.d(tag, "init success");
					Toast.makeText(mActivity, "初始化成功", Toast.LENGTH_SHORT).show();
				}

				@Override
				public void onFailed(String msg) {
					Toast.makeText(mActivity, "初始化失败:" + msg, Toast.LENGTH_SHORT).show();
				}
			});
		}
	}

	public void setHideVirtualKey(Window window) {
		int uiOptions = View.SYSTEM_UI_FLAG_LAYOUT_STABLE | View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
				| View.SYSTEM_UI_FLAG_FULLSCREEN | View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
				| View.SYSTEM_UI_FLAG_LAYOUT_FULLSCREEN;
		if (Build.VERSION.SDK_INT >= 19) {
			uiOptions |= 0x00001000;
		} else {
			uiOptions |= View.SYSTEM_UI_FLAG_LOW_PROFILE;
		}
		window.getDecorView().setSystemUiVisibility(uiOptions);
	}

	public void pay(View v) {

		mRoleInfo.setRoleId("123546421321");
		mRoleInfo.setRoleLevel("1");
		mRoleInfo.setRoleName("hhaha");
		mRoleInfo.setServerName("zzz");
		mRoleInfo.setVipLevel("666");
		if (amountEditText.getText() != null) {
			mOrderInfo.setAmount(amountEditText.getText().toString());
		} else {
			mOrderInfo.setAmount("10");
		}
		// 订单信息

		mOrderInfo.setCount(1); // 数量
		mOrderInfo.setExtrasParams("2017110403"); // 订单号
		mOrderInfo.setPayParam("eedwd");// 商品描述
		mOrderInfo.setOrderSubject("钻石"); // 商品名称
		mOrderInfo.setProductOrderId("2017110403");// cp订单号

		QGManager.pay(mActivity, mRoleInfo, mOrderInfo, new QGCallBack() {
			@Override
			public void onSuccess() {
				Toast.makeText(mActivity, "支付成功", Toast.LENGTH_SHORT).show();

			}

			@Override
			public void onFailed(String msg) {
				Toast.makeText(mActivity, msg, Toast.LENGTH_SHORT).show();

			}
		});

	}

	public void login(View v) {
		MainActivity.this.runOnUiThread(new Runnable() {

			@Override
			public void run() {
				// TODO Auto-generated method stub

				QGManager.login(mActivity, new QGCallBack() {

					@Override
					public void onSuccess() {
						// TODO Auto-generated method stub
						Toast.makeText(mActivity, "登录成功，uid=" + QGManager.getUID(), Toast.LENGTH_SHORT).show();
					}

					@Override
					public void onFailed(String msg) {
						// TODO Auto-generated method stub
						Toast.makeText(mActivity, "登录失败: " + msg, Toast.LENGTH_SHORT).show();

					}
				});
			}
		});
	}

	public void setGameRoleInfo(View v) {
		QGRoleInfo roleInfo = new QGRoleInfo();
		roleInfo.setBalance("9999");
		roleInfo.setPartyName("宇宙第一");
		roleInfo.setRoleId("10086");
		roleInfo.setRoleLevel("10086");
		roleInfo.setRoleName("宇宙第一");
		roleInfo.setServerName("888");
		roleInfo.setVipLevel("999");
		QGManager.setGameRoleInfo(MainActivity.this, roleInfo);
	}

	public void logout(View v) {
		QGManager.logout(this);
	}

	@Override
	protected void onPause() {
		super.onPause();
		QGManager.hideFloat();
	}

	@Override
	protected void onResume() {
		super.onResume();
		if (!TextUtils.isEmpty(QGManager.getUID())) {
			QGManager.showFloat(false);
		}

	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			QGManager.exit(this, new QGCallBack() {
				@Override
				public void onSuccess() {
					finish();
				}

				@Override
				public void onFailed(String msg) {
				}
			});
		}
		// TODO Auto-generated method stub
		return super.onKeyDown(keyCode, event);
	}

	// 游戏发货时调用
	public void test() {
		QGManager
				.adPayStatistics(QGManager.getUID(), QGManager.getUserName(), "角色id", "订单号", "商品id", "商品名称", 1.0f, "1");
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		// TODO Auto-generated method stub
		super.onActivityResult(requestCode, resultCode, data);
		if (requestCode == 10001) {
			if (resultCode == 1) {
				Log.d("quickgame", "绑定成功");
			} else {
				Log.d("quickgame", "绑定失败");
			}
		}
	}
}
